#!/usr/bin/perl
###########################
##  AutoRank Pro v3.0.x  ##
##################################################
##  arp.pl - AutoRank Pro shared functions      ##
##################################################

package arp;

use lib '.';                                      ## You may need to set this to the full path to cgiworks.pm
use strict;
use cgiworks;

$arp::ver = '3.0.0a3';

require "$DDIR/vars.dat" if( -e "$DDIR/vars.dat" );
require 'sort.pl';

1;

#################################################################################
##  Removing any code from this file which creates the link back to CGI Works  ##
##  is a copyright violation.  If your site is found to have removed the link  ##
##  your software license will be terminated and the proper authorities will   ##
##  be contacted.  Do not remove any code that creates the link to CGI Works.  ##
#################################################################################

sub rerank {
  my $build = shift;
  *sortem = $VAR::RB;
  &sortem('Overall');
  my $rank = 1;
  my $rtot = scalar( @srt::sort );
  my $fld  = unpack('u', ${ freadalls("$DDIR/dbs/bdata") });
  my(%brk, %crank, %cats);
  for( split(/,/, $VAR::BO) ) { $brk{$_} = 1; }
  for( split(/,/, $VAR::CT) ) { $crank{$_} = 1; }
  my $reset = (stat("$DDIR/times/reset"))[9];

  %TPL = %srt::cats;
  $TPL{'CURL'}  = $VAR::CU;
  $TPL{'LUPDT'} = fdate($VAR::DF, time + (3600 * $VAR::TZ)) . " " . ftime($VAR::TF, time + (3600 * $VAR::TZ));
  $TPL{'NUPDT'} = fdate($VAR::DF, time + (3600 * $VAR::TZ) + $VAR::RR) . " " . ftime($VAR::TF, time + (3600 * $VAR::TZ) + $VAR::RR);
  $TPL{'LRSET'} = fdate($VAR::DF, $reset + (3600 * $VAR::TZ)) . " " . ftime($VAR::TF, $reset + (3600 * $VAR::TZ));
  $TPL{'NRSET'} = fdate($VAR::DF, $reset + (3600 * $VAR::TZ) + $VAR::RS) . " " . ftime($VAR::TF, $reset + (3600 * $VAR::TZ) + $VAR::RS);
  $TPL{'TOT'}   = $srt::tot;
  $TPL{'CATS'}  = getcats();

  for( split(/,/, $VAR::PO) ) {
    require "$DDIR/html/$_";
    my $page = $_;
    my( $start, $end ) = split(/-/, $VAR::SP{$_});
    $end = $rtot if( $end > $rtot );

    som( getrand($start, $end) );

    open(HTML, ">$VAR::HD/$_") || err($!, $_);
    vparse($HTML::HEAD, \*HTML);  $HTML::FOOT .= $fld;
    my $i;
    for( $i = $start; $i <= $end; $i++ ) {
      last if( $i > $VAR::OL || !defined($srt::sort[$i - 1]) );
      my $mem = getmem($srt::sort[$i - 1]);
      my $md = fsplit("$DDIR/members/$mem.dat");
      my @cd = split(/\|/, $srt::mem{"$mem.cnt"});
      my $age = time - $cd[9];

      $TPL{'USER'}   = $mem;
      $TPL{'FSIZE'}  = $VAR::FT{$rank} if( defined $VAR::FT{$rank} );
      $TPL{'ORANK'}  = $i;
      $TPL{'CRANK'}  = $crank{$cd[7]};
      $TPL{'URL'}    = $OPT::OUT ? $VAR::OU . "?id=$mem&url=" . urlencode($md->[1]) : $md->[1];
      $TPL{'TITLE'}  = $md->[6];
      $TPL{'DESC'}   = $md->[7];
      $TPL{'CAT'}    = $md->[8];
      $TPL{'ICONS'}  = geticons($md->[9]);
      $TPL{'FLD1'}   = $md->[23];
      $TPL{'FLD2'}   = $md->[24];
      $TPL{'FLD3'}   = $md->[25];
      $TPL{'PORANK'} = $md->[16];
      $TPL{'PCRANK'} = $md->[17];
      $TPL{'PIN'}    = $md->[14];
      $TPL{'POUT'}   = $md->[15];
      $TPL{'PSORT'}  = $md->[13];
      $TPL{'IN'}     = int($cd[1] * $cd[6]);
      $TPL{'OUT'}    = $cd[2];
      $TPL{'TIN'}    = int($cd[3] * $cd[6]);
      $TPL{'TOUT'}   = $cd[4];
      $TPL{'IPDAY'}  = getavg($TPL{'TIN'}, $age, 86400);
      $TPL{'IPWEK'}  = getavg($TPL{'TIN'}, $age, 604800);
      $TPL{'IPMTH'}  = getavg($TPL{'TIN'}, $age, 2592000);
      $TPL{'OPDAY'}  = getavg($TPL{'TOUT'}, $age, 86400);
      $TPL{'OPWEK'}  = getavg($TPL{'TOUT'}, $age, 604800);
      $TPL{'OPMTH'}  = getavg($TPL{'TOUT'}, $age, 2592000);
      $TPL{'NEW'}    = $age <= $VAR::NS ? $VAR::NI : '';
      $TPL{'BANNER'} = $md->[2] ne '' && $i <= $VAR::OB ? qq|<img src="$md->[2]" height="$md->[3]" width="$md->[4]" border="0" alt="Banner"><br>| : '';
      $TPL{'MOVE'}   = $VAR::SI;
      if( $md->[16] ne 'N/A' ) {
        if( $md->[16] > $i ) {
          $TPL{'MOVE'}   = $VAR::UI;
        } elsif( $md->[16] < $i ) {
          $TPL{'MOVE'}   = $VAR::DI;
        }
      }
      my $cat = $i - 1;
      $cats{ htmlname($md->[8]) . ".$VAR::FE" } .= "$cat,";
      vparse($HTML::TEMP, \*HTML);

      if( defined $brk{$rank} && -e "$DDIR/breaks/$rank.$VAR::RP" ) {
        print HTML ${ freadalls("$DDIR/breaks/$rank.$VAR::RP") };
      }
      $rank++; $crank{$cd[7]}++;
    }
    vparse($HTML::FOOT, \*HTML);
    close(HTML);
    mode(0666, "$VAR::HD/$page");
  }

  if( $OPT::GSP && $build ) {
    for( split(/,/, $VAR::PC) ) {
      require "$DDIR/html/$_";
      my $page = $_;
      my $crank = 1;

      if( $cats{$page} ) {
        som( getrandcat($cats{$page}) + 1 );
      }
      else {
        $TPL{'SOMURL'} = $TPL{'SOMTITLE'} = $TPL{'SOMBAN'} = $TPL{'SOMDESC'} = $TPL{'SOMICONS'} = '';
      }

      open(HTML, ">$VAR::HD/$_") || err($!, $_);
      vparse($HTML::HEAD, \*HTML);  $HTML::FOOT .= $fld;

      for( split(/,/, $cats{$page}) ) {
        last if( $crank > $VAR::CL );
        my $mem = getmem($srt::sort[$_]);
        next if( $mem eq '' );
        my @cd = split(/\|/, $srt::mem{"$mem.cnt"});
        my $md = fsplit("$DDIR/members/$mem.dat");
        my $age = time - $cd[9];

        $TPL{'USER'}   = $mem;
        $TPL{'FSIZE'}  = $VAR::TC{$crank} if( defined $VAR::TC{$crank} );
        $TPL{'ORANK'}  = $_ + 1;
        $TPL{'CRANK'}  = $crank;
        $TPL{'URL'}    = $OPT::OUT ? $VAR::OU . "?id=$mem&url=" . urlencode($md->[1]) : $md->[1];
        $TPL{'TITLE'}  = $md->[6];
        $TPL{'DESC'}   = $md->[7];
        $TPL{'CAT'}    = $md->[8];
        $TPL{'ICONS'}  = geticons($md->[9]);
        $TPL{'FLD1'}   = $md->[23];
        $TPL{'FLD2'}   = $md->[24];
        $TPL{'FLD3'}   = $md->[25];
        $TPL{'PORANK'} = $md->[16];
        $TPL{'PCRANK'} = $md->[17];
        $TPL{'PIN'}    = $md->[14];
        $TPL{'POUT'}   = $md->[15];
        $TPL{'PSORT'}  = $md->[13];
        $TPL{'IN'}     = int($cd[1] * $cd[6]);
        $TPL{'OUT'}    = $cd[2];
        $TPL{'TIN'}    = int($cd[3] * $cd[6]);
        $TPL{'TOUT'}   = $cd[4];
        $TPL{'IPDAY'}  = getavg($TPL{'TIN'}, $age, 86400);
        $TPL{'IPWEK'}  = getavg($TPL{'TIN'}, $age, 604800);
        $TPL{'IPMTH'}  = getavg($TPL{'TIN'}, $age, 2592000);
        $TPL{'OPDAY'}  = getavg($TPL{'TOUT'}, $age, 86400);
        $TPL{'OPWEK'}  = getavg($TPL{'TOUT'}, $age, 604800);
        $TPL{'OPMTH'}  = getavg($TPL{'TOUT'}, $age, 2592000);
        $TPL{'NEW'}    = $age <= $VAR::NS ? $VAR::NI : '';
        $TPL{'BANNER'} = $md->[2] ne '' && $crank <= $VAR::CB ? qq|<img src="$md->[2]" height="$md->[3]" width="$md->[4]" border="0" alt="Banner">| : '';
        $TPL{'MOVE'}   = $VAR::SI;
        if( $md->[17] ne 'N/A' ) {
          if( $md->[17] > $crank ) {
            $TPL{'MOVE'}   = $VAR::UI;
          } elsif( $md->[17] < $crank ) {
            $TPL{'MOVE'}   = $VAR::DI;
          }
        }

        vparse($HTML::TEMP, \*HTML);

        if( defined $brk{$crank} && -e "$DDIR/breaks/$crank.$page" ) {
          print HTML ${ freadalls("$DDIR/breaks/$crank.$page") };
        }

        $crank++;
      }
      vparse($HTML::FOOT, \*HTML);
      close(HTML);
      mode(0666, "$VAR::HD/$page");
    }
  }
}

sub som {
  my $som = shift;
  my $mem = getmem($srt::sort[$som - 1]);
  my $md = fsplit("$DDIR/members/$mem.dat") if( -e "$DDIR/members/$mem.dat" );

  $TPL{'SOMURL'}   = $OPT::OUT ? $VAR::OU . "?id=$mem&url=" . urlencode($md->[1]) : $md->[1];
  $TPL{'SOMTITLE'} = $md->[6];
  $TPL{'SOMBAN'}   = $md->[2] ne '' ? qq|<img src="$md->[2]" height="$md->[3]" width="$md->[4]" border="0" alt="Banner"><br>| : '';
  $TPL{'SOMDESC'}  = $md->[7];
  $TPL{'SOMICONS'} = geticons($md->[9]);
}

sub resetlist {
  $srt::filter = 0;
  *sortem = $VAR::RB;
  &sortem('Overall');
  my( %cr, $or, %st );
  my $time = time;

  for( @srt::sort ) {
    my @cd = split(/\|/, $srt::mem{$_});
    my $mb = getmem($_);
    $or++; $cr{$cd[7]}++;

    fjoin("$DDIR/members/$_", 0, 0, @cd[3..9]);
    my $md = fsplit("$DDIR/members/$mb.dat");
    $md->[13] = $cd[0];
    $md->[14] = $cd[1] * $cd[6];
    $md->[15] = $cd[2];
    $md->[16] = $or;
    $md->[17] = $cr{$cd[7]};
    $md->[22] = int($cd[1]) ? 0 : $md->[22] + 1;
    fjoin("$DDIR/members/$mb.dat", @{ $md });
    fappend("$DDIR/members/$mb.sts", fdate('%m-%d-%y', $time) . "|$cd[1]|$cd[2]|$cd[3]|$cd[4]|$cd[5]|$cd[6]|$cd[9]|$or|$cr{$cd[7]}|$cd[8]|$time\n");

    $st{'in'}   += $cd[1];
    $st{'out'}  += $cd[2];
    $st{'tin'}  += $cd[3];
    $st{'tout'} += $cd[4];
    $st{'act'}++ if( int($cd[1]) );
  }
  fappend("$DDIR/stats", fdate('%m-%d-%y', $time) . "|$st{'in'}|$st{'out'}|$st{'tin'}|$st{'tout'}|" . int($st{'act'}) . "|" . getmem($srt::sort[0]) . "|$time\n");
}

sub getrand {
  my($a, $b) = @_;
  my $rand = int(rand( $b - $a + 1 )) + $a;
  return $rand;
}

sub getrandcat {
  my @sel = split(/,/, shift);
  return $sel[ rand @sel ];
}

sub getavg {
  my( $cnt, $age, $len ) = @_;
  return sprintf("%.$VAR::DP" . "f", $age >= $len ? $cnt / ($age / $len) : $cnt);
}

sub geticons {
  my($ico, $html) = shift;
  for( split(/,/, $ico) ) {
    next if( $_ eq '' || (!-e "$DDIR/icons/$_"));
    $html .= ${ freadalls("$DDIR/icons/$_") } . '&nbsp;';
    $html =~ s/\n&nbsp;/&nbsp;/g;
  }
  $html =~ s/&nbsp;$//g;
  return $html;
}

sub htmlname {
  my $name = lc( shift );
  $name =~ s/[^a-zA-Z0-9_]//g;
  return $name;
}

sub getage {
  my $file = shift;
  return time - (stat($file))[9];
}

sub getmem {
  my $id = shift;
  $id =~ s/\..+$//;
  return $id;
}

sub getcats {
  my( $in, $html ) = shift;
  for( split(/,/, $VAR::CT) ) {
    $html .= qq|<option value="$_"|;
    $html .= ' selected' if( $in eq $_ );
    $html .= qq|>$_</option>|;
  }
  return $html;
}
